% Solar insolation calculation parameter inputs
Rsc = 1367; % W/m2, Solar constant
%
L = x; % Latitude (degrees); Here you enter the latitude of the site for each region
%
pie = 3.141592654; % pie

% Downward daily solar radiation at TOA ("Extraterrestrial solar radiation on horizontal surface") -- Duffie & Beckman, (1991); Kalogirou, (2009)
R_TOA = zeros(365,1);
for i = 1:365; % i = Julian Day
dec = 23.45*sind(360*(284+i)/365); % Angle of declination in degrees
sshr = acosd(-tand(L)*tand(dec)); % Sunset hr. angle in degrees
R_TOA(i,:) = ((Rsc/pie)*(1+0.033*cosd((360*i)/365)))*(((cosd(L)*cosd(dec)*sind(sshr))+(((pie*sshr)/180)*sind(L)*sind(dec)))); % TOA irradiance on day "i"
end

R_TOA_ann = sum(R_TOA)/365; % Mean annual instantaneous R_TOA (local W/m2/year, south Norway)
% Monthly mean incoming radiation at top of atmosphere ("TOA")
R_TOA_month = zeros(1,12);
R_TOA_month(:,1) = (sum(R_TOA(1:31,1)))/31; %  January mean
R_TOA_month(:,2) = (sum(R_TOA(32:59,1)))/28; % February mean...
R_TOA_month(:,3) = (sum(R_TOA(60:90,1)))/31;
R_TOA_month(:,4) = (sum(R_TOA(91:120,1)))/30;
R_TOA_month(:,5) = (sum(R_TOA(121:151,1)))/31;
R_TOA_month(:,6) = (sum(R_TOA(152:181,1)))/30;
R_TOA_month(:,7) = (sum(R_TOA(182:212,1)))/31;
R_TOA_month(:,8) = (sum(R_TOA(213:243,1)))/31;
R_TOA_month(:,9) = (sum(R_TOA(244:273,1)))/30;
R_TOA_month(:,10) = (sum(R_TOA(274:304,1)))/31;
R_TOA_month(:,11) = (sum(R_TOA(305:334,1)))/30;
R_TOA_month(:,12) = (sum(R_TOA(335:365,1)))/31;